diff -Naur tomato/release/src/router/pptp-client/pptp_gre.h tomato121/release/src/router/pptp-client/pptp_gre.h
--- tomato/release/src/router/pptp-client/pptp_gre.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/pptp_gre.h	2008-04-22 21:44:06.000000000 +1000
@@ -2,10 +2,50 @@
  *               Handle the IP Protocol 47 portion of PPTP.
  *               C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: pptp_gre.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: pptp_gre.h,v 1.5 2004/06/09 00:13:32 quozl Exp $
  */
 
-/*void pptp_gre_copy(u_int16_t call_id, u_int16_t peer_call_id,
-		   char *pty, char *inetaddr);*/
+int pptp_gre_bind(struct in_addr inetaddr);
 void pptp_gre_copy(u_int16_t call_id, u_int16_t peer_call_id,
-		   int pty_fd, struct in_addr inetaddr);
+		   int pty_fd, int gre_fd);
+
+extern int syncppp;
+extern int disable_buffer;
+
+typedef struct pack_track {
+  uint32_t seq;       // seq no of this tracked packet
+  uint64_t time;      // time when this tracked packet was sent (in usecs)
+} pack_track_t;
+
+typedef struct gre_stats {
+  /* statistics for GRE receive */
+
+  uint32_t rx_accepted;  // data packet was passed to pppd
+  uint32_t rx_lost;      // data packet did not arrive before timeout
+  uint32_t rx_underwin;  // data packet was under window (arrived too late
+                         // or duplicate packet)
+  uint32_t rx_overwin;   // data packet was over window
+                         // (too many packets lost?)
+  uint32_t rx_buffered;  // data packet arrived earlier than expected,
+                         // packet(s) before it were lost or reordered
+  uint32_t rx_errors;    // OS error on receive
+  uint32_t rx_truncated; // truncated packet
+  uint32_t rx_invalid;   // wrong protocol or invalid flags 
+  uint32_t rx_acks;      // acknowledgement only
+
+  /* statistics for GRE transmit */
+
+  uint32_t tx_sent;      // data packet write() to GRE socket succeeded
+  uint32_t tx_failed;    // data packet write() to GRE socket returned error
+  uint32_t tx_short;     // data packet write() to GRE socket underflowed
+  uint32_t tx_acks;      // sent packet with just ACK
+  uint32_t tx_oversize;  // data packet dropped because it was too large
+
+  /* statistics for packet tracking, for RTT calculation */
+
+  pack_track_t pt;       // last data packet seq/time
+  int rtt;               // estimated round-trip time in us
+
+} gre_stats_t;
+
+extern gre_stats_t stats;
diff -Naur tomato/release/src/router/pptp-client/pptp_msg.h tomato121/release/src/router/pptp-client/pptp_msg.h
--- tomato/release/src/router/pptp-client/pptp_msg.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/pptp_msg.h	2008-04-22 21:44:06.000000000 +1000
@@ -1,7 +1,7 @@
 /*  pptp.h:  packet structures and magic constants for the PPTP protocol 
  *           C. Scott Ananian <cananian@alumni.princeton.edu>            
  *
- * $Id: pptp_msg.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: pptp_msg.h,v 1.3 2003/02/15 10:37:21 quozl Exp $
  */
 
 #ifndef INC_PPTP_H
@@ -71,30 +71,7 @@
 #define PPTP_BEARER_DIGITAL 	2
 #define PPTP_BEARER_ANY		3
 
-/* PPTP error codes: ----------------------------------------------*/
-
-/* (General Error Codes) */
-static const struct {
-  const char *name, *desc;
-} pptp_general_errors[] = {
-
-#define PPTP_GENERAL_ERROR_NONE			0
-  { "(None)", "No general error" },
-#define PPTP_GENERAL_ERROR_NOT_CONNECTED	1
-  { "(Not-Connected)", "No control connection exists yet for this "
-                       "PAC-PNS pair" },
-#define PPTP_GENERAL_ERROR_BAD_FORMAT		2
-  { "(Bad-Format)", "Length is wrong or Magic Cookie value is incorrect" },
-#define PPTP_GENERAL_ERROR_BAD_VALUE		3
-  { "(Bad-Value)", "One of the field values was out of range or "
-                    "reserved field was non-zero" },
-#define PPTP_GENERAL_ERROR_NO_RESOURCE		4
-  { "(No-Resource)", "Insufficient resources to handle this command now" },
-#define PPTP_GENERAL_ERROR_BAD_CALLID		5
-  { "(Bad-Call ID)", "The Call ID is invalid in this context" },
-#define PPTP_GENERAL_ERROR_PAC_ERROR		6
-  { "(PAC-Error)", "A generic vendor-specific error occured in the PAC" }
-};
+#define PPTP_RESULT_GENERAL_ERROR 2
 
 /* (Reasons to close a connection) */
 #define PPTP_STOP_NONE		  1 /* no good reason                        */
diff -Naur tomato/release/src/router/pptp-client/pptp_options.h tomato121/release/src/router/pptp-client/pptp_options.h
--- tomato/release/src/router/pptp-client/pptp_options.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/pptp_options.h	2008-04-22 21:44:06.000000000 +1000
@@ -2,18 +2,18 @@
  *                       #define STANDARD to emulate NT 4.0 exactly.
  *                       C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: pptp_options.h,v 1.3 2004/07/27 06:20:15 honor Exp $
+ * $Id: pptp_options.h,v 1.3 2004/11/09 01:42:32 quozl Exp $
  */
 
-#include <cyutils.h>
-
 #ifndef INC_PPTP_OPTIONS_H
 #define INC_PPTP_OPTIONS_H
 
 #undef  PPTP_FIRMWARE_STRING
 #undef  PPTP_FIRMWARE_VERSION
 #define PPTP_BUF_MAX 65536
-#define PPTP_TIMEOUT 15 /* seconds */
+#define PPTP_TIMEOUT 60 /* seconds */
+extern int idle_wait;
+extern int max_echo_wait;
 #define PPTP_CONNECT_SPEED 10000000
 #define PPTP_WINDOW 3
 #define PPTP_DELAY  0
@@ -24,8 +24,8 @@
 #define PPTP_MAX_CHANNELS 65535
 #define PPTP_FIRMWARE_STRING "0.01"
 #define PPTP_FIRMWARE_VERSION 0x001
-//#define PPTP_HOSTNAME {'l','o','c','a','l',0}
-//#define PPTP_VENDOR   {'c','a','n','a','n','i','a','n',0}
+#define PPTP_HOSTNAME {'l','o','c','a','l',0}
+#define PPTP_VENDOR   {'c','a','n','a','n','i','a','n',0}
 #define PPTP_FRAME_CAP  PPTP_FRAME_ANY
 #define PPTP_BEARER_CAP PPTP_BEARER_ANY
 #else
diff -Naur tomato/release/src/router/pptp-client/pptp_quirks.c tomato121/release/src/router/pptp-client/pptp_quirks.c
--- tomato/release/src/router/pptp-client/pptp_quirks.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/pptp_quirks.c	2008-04-22 21:44:06.000000000 +1000
@@ -1,7 +1,7 @@
 /* pptp_quirks.c ...... various options to fix quirks found in buggy adsl modems
  *                      mulix <mulix@actcom.co.il>
  *
- * $Id: pptp_quirks.c,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: pptp_quirks.c,v 1.2 2001/11/23 03:42:51 quozl Exp $
  */
 
 #include <string.h>
diff -Naur tomato/release/src/router/pptp-client/pptp_quirks.h tomato121/release/src/router/pptp-client/pptp_quirks.h
--- tomato/release/src/router/pptp-client/pptp_quirks.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/pptp_quirks.h	2008-04-22 21:44:06.000000000 +1000
@@ -1,7 +1,7 @@
 /* pptp_quirks.h ...... various options to fix quirks found in buggy adsl modems
  *                      mulix <mulix@actcom.co.il>
  *
- * $Id: pptp_quirks.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: pptp_quirks.h,v 1.1 2001/11/20 06:30:10 quozl Exp $
  */
 
 #ifndef INC_PPTP_QUIRKS_H
diff -Naur tomato/release/src/router/pptp-client/pqueue.c tomato121/release/src/router/pptp-client/pqueue.c
--- tomato/release/src/router/pptp-client/pqueue.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/pqueue.c	2008-04-22 21:44:06.000000000 +1000
@@ -0,0 +1,234 @@
+#include <errno.h>
+#include <stdlib.h>
+#include <string.h>
+#include <assert.h>
+
+#include "util.h" // for log()
+#include "pqueue.h"
+
+#ifdef DEBUG_PQUEUE
+#define DEBUG_ON 1
+#else
+#define DEBUG_ON 0
+#endif
+
+#define DEBUG_CMD(_a) if (DEBUG_ON) { _a }
+
+
+#define MIN_CAPACITY 128 /* min allocated buffer for a packet */
+
+static int pqueue_alloc (int seq, unsigned char *packet, int packlen, pqueue_t **new);
+
+int packet_timeout_usecs = DEFAULT_PACKET_TIMEOUT * 1000000;
+
+
+static pqueue_t *pq_head = NULL, *pq_tail = NULL;
+
+/* contains a list of free queue elements.*/
+static pqueue_t *pq_freelist_head = NULL;
+
+
+
+static int pqueue_alloc(int seq, unsigned char *packet, int packlen, pqueue_t **new) {
+
+  pqueue_t *newent;
+
+  DEBUG_CMD(log("seq=%d, packlen=%d", seq, packlen););
+
+  /* search the freelist for one that has sufficient space  */
+  if (pq_freelist_head) {
+
+    for (newent = pq_freelist_head; newent; newent = newent->next) {
+
+      if (newent->capacity >= packlen) {
+
+ 	/* unlink from freelist */
+	if (pq_freelist_head == newent) 
+	  pq_freelist_head = newent->next;
+
+	if (newent->prev) 
+	  newent->prev->next = newent->next;
+
+	if (newent->next) 
+	  newent->next->prev = newent->prev;
+
+	if (pq_freelist_head) 
+	  pq_freelist_head->prev = NULL;
+
+	break;
+      }	/* end if capacity >= packlen */
+    } /* end for */
+	
+    /* nothing found? Take first and reallocate it */
+    if (NULL == newent) {
+
+      newent = pq_freelist_head;
+      pq_freelist_head = pq_freelist_head->next;
+
+      if (pq_freelist_head) 
+	pq_freelist_head->prev = NULL;
+
+      DEBUG_CMD(log("realloc capacity %d to %d",newent->capacity, packlen););
+
+      newent->packet = (unsigned char *)realloc(newent->packet, packlen);
+
+      if (!newent->packet) {
+	warn("error reallocating packet: %s", strerror(errno));
+	return -1;
+      }
+      newent->capacity = packlen;
+    }
+    
+    DEBUG_CMD(log("Recycle entry from freelist. Capacity: %d", newent->capacity););
+
+  } else {
+
+    /* allocate a new one */
+    newent = (pqueue_t *)malloc( sizeof(pqueue_t) );
+    if (!newent) {
+      warn("error allocating newent: %s", strerror(errno));
+      return -1;
+    }
+    newent->capacity = 0;
+
+    DEBUG_CMD(log("Alloc new queue entry"););
+  }
+
+  if ( ! newent->capacity  ) {
+    /* a new queue entry was allocated. Allocate the packet buffer */
+    int size = packlen < MIN_CAPACITY ? MIN_CAPACITY : packlen;
+    /* Allocate at least MIN_CAPACITY */
+    DEBUG_CMD(log("allocating for packet size %d", size););
+    newent->packet = (unsigned char *)malloc(size);
+    if (!newent->packet) {
+      warn("error allocating packet: %s", strerror(errno));
+      return -1;
+    }
+    newent->capacity = size;
+  } /* endif ! capacity */
+  assert( newent->capacity >= packlen );
+  /* store the contents into the buffer */
+  memcpy(newent->packet, packet, packlen);
+
+  newent->next = newent->prev = NULL;
+  newent->seq     = seq;
+  newent->packlen = packlen;
+
+  gettimeofday(&newent->expires, NULL);
+  newent->expires.tv_usec += packet_timeout_usecs;
+  newent->expires.tv_sec  += (newent->expires.tv_usec / 1000000);
+  newent->expires.tv_usec %= 1000000;
+
+  *new = newent;
+  return 0;
+}
+
+
+
+int pqueue_add (int seq, unsigned char *packet, int packlen) {
+  pqueue_t *newent, *point;
+
+  /* get a new entry */
+  if ( 0 != pqueue_alloc(seq, packet, packlen, &newent) ) {
+    return -1;
+  }
+
+  for (point = pq_head; point != NULL; point = point->next) {
+    if (point->seq == seq) {
+      // queue already contains this packet
+      warn("discarding duplicate packet %d", seq);
+      return -1;
+    }
+    if (point->seq > seq) {
+      // gone too far: point->seq > seq and point->prev->seq < seq
+      if (point->prev) {
+	// insert between point->prev and point
+	DEBUG_CMD(log("adding %d between %d and %d", 
+		      seq, point->prev->seq, point->seq););
+
+	point->prev->next = newent;
+      } else {
+	// insert at head of queue, before point
+	DEBUG_CMD(log("adding %d before %d", seq, point->seq););
+	pq_head = newent;
+      }
+      newent->prev = point->prev; // will be NULL, at head of queue
+      newent->next = point;
+      point->prev = newent;
+      return 0;
+    }
+  }
+
+  /* We didn't find anywhere to insert the packet,
+   * so there are no packets in the queue with higher sequences than this one,
+   * so all the packets in the queue have lower sequences,
+   * so this packet belongs at the end of the queue (which might be empty)
+   */
+  
+  if (pq_head == NULL) {
+    DEBUG_CMD(log("adding %d to empty queue", seq););
+    pq_head = newent;
+  } else {
+    DEBUG_CMD(log("adding %d as tail, after %d", seq, pq_tail->seq););
+    pq_tail->next = newent;
+  }
+  newent->prev = pq_tail;
+  pq_tail = newent;
+
+  return 0;
+}
+
+
+
+int pqueue_del (pqueue_t *point) {
+
+  DEBUG_CMD(log("Move seq %d to freelist", point->seq););
+
+  /* unlink from pq */
+  if (pq_head == point) pq_head = point->next;
+  if (pq_tail == point) pq_tail = point->prev;
+  if (point->prev) point->prev->next = point->next;
+  if (point->next) point->next->prev = point->prev;
+
+  /* add point to the freelist */
+  point->next = pq_freelist_head;
+  point->prev = NULL;
+
+  if (point->next)
+    point->next->prev = point;
+  pq_freelist_head = point;
+
+  DEBUG_CMD(
+    int pq_count = 0;
+    int pq_freelist_count = 0;
+    pqueue_t *point;
+    for ( point = pq_head; point ; point = point->next) {
+      ++pq_count;
+    }
+
+    for ( point = pq_freelist_head; point ; point = point->next) {
+      ++pq_freelist_count;
+    }
+    log("queue length is %d, freelist length is %d", pq_count, pq_freelist_count);
+    );
+
+  return 0;
+}
+
+
+
+pqueue_t *pqueue_head () {
+  return pq_head;
+}
+
+
+
+int pqueue_expiry_time (pqueue_t *entry) {
+  struct timeval tv;
+  int expiry_time;
+
+  gettimeofday(&tv, NULL);
+  expiry_time  = (entry->expires.tv_sec  - tv.tv_sec) * 1000000;
+  expiry_time += (entry->expires.tv_usec - tv.tv_usec);
+  return expiry_time;
+}
diff -Naur tomato/release/src/router/pptp-client/pqueue.h tomato121/release/src/router/pptp-client/pqueue.h
--- tomato/release/src/router/pptp-client/pqueue.h	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/pqueue.h	2008-04-22 21:44:06.000000000 +1000
@@ -0,0 +1,30 @@
+#ifndef PQUEUE_H
+#define PQUEUE_H
+
+#include <time.h>
+#include <sys/time.h>
+
+/* wait this many seconds for missing packets before forgetting about them */
+#define DEFAULT_PACKET_TIMEOUT 0.3
+extern int packet_timeout_usecs;
+
+/* assume packet is bad/spoofed if it's more than this many seqs ahead */
+#define MISSING_WINDOW 300
+
+/* Packet queue structure: linked list of packets received out-of-order */
+typedef struct pqueue {
+  struct pqueue *next;
+  struct pqueue *prev;
+  int seq;
+  struct timeval expires;
+  unsigned char *packet;
+  int packlen;
+  int capacity;
+} pqueue_t;
+
+int       pqueue_add  (int seq, unsigned char *packet, int packlen);
+int       pqueue_del  (pqueue_t *point);
+pqueue_t *pqueue_head ();
+int       pqueue_expiry_time (pqueue_t *entry);
+
+#endif /* PQUEUE_H */
diff -Naur tomato/release/src/router/pptp-client/README tomato121/release/src/router/pptp-client/README
--- tomato/release/src/router/pptp-client/README	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/README	2008-04-22 21:44:06.000000000 +1000
@@ -1,31 +1,35 @@
-pptp-linux
+pptp
 
-pptp-linux is an implementation of the PPTP protocol for Linux and
+pptp is an implementation of the PPTP protocol for Linux and
 other Unix systems.
 
 The code is released under the terms of the GPL; see the file COPYING
 for details.
 
-You can find notes on installing and using this package in the file
-USING; design notes are in the Documentation directory; and the
-standards documents used to implement pptp-linux can be found in the
+You can find notes on installing in the file INSTALL, usage notes in
+the file USING, design notes in the Documentation directory, and the
+standards documents used to implement pptp can be found in the
 Reference directory.
 
 New versions and additional documentation can be found on the PPTP
 Client project page, at http://pptpclient.sourceforge.net/
 
-Discussion of this code now occurs on the mailing list for the PPTP
-Client project on SourceForge.  To subscribe, visit the project's
-mailing lists page, or
+Discussion of this code occurs on the mailing list for the PPTP Client
+project on SourceForge.  To subscribe, visit the project's mailing
+lists page, or
 
 http://lists.sourceforge.net/lists/listinfo/pptpclient-devel
 
 Discussion of this code used to occur on the mailing list
 pptp@debs.fuller.edu, subscribe by sending "subscribe" in the body on
 an email to pptp-request@debs.fuller.edu, or look at
-http://debs.fuller.edu.  Christoph Lameter is the list organizer.
+http://debs.fuller.edu.  Christoph Lameter was the list organizer.
 
 Re-organization and patches are of course greatly welcomed.
+See the file TODO.
 
-C. Scott Ananian <cananian@alumni.princeton.edu>
-James Cameron <james.cameron@compaq.com>
+James Cameron <james.cameron@hp.com> (maintainer, release engineer)
+C. Scott Ananian <cananian@alumni.princeton.edu> (original author)
+
+
+$Id: README,v 1.4 2004/06/22 09:52:26 quozl Exp $	
diff -Naur tomato/release/src/router/pptp-client/Reference/README tomato121/release/src/router/pptp-client/Reference/README
--- tomato/release/src/router/pptp-client/Reference/README	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/Reference/README	2008-04-22 21:44:06.000000000 +1000
@@ -1,5 +1,5 @@
 In this directory are the various standards documents implemented in
-the pptp-linux package.
+the pptp package.
 
 rfc791.txt		Internet Protocol (IP).
 rfc793.txt		Transmission Control Protocol (TCP).
@@ -11,5 +11,5 @@
 ms-chap.txt		Microsoft PPP CHAP extensions.
 pptp-draft.txt		July 1997 draft of the PPTP standard.
 
-rfc1990 is currently unimplemented in pptp-linux.
+rfc1990 is currently unimplemented in pptp
                                                         CSA, 12/12/97
diff -Naur tomato/release/src/router/pptp-client/Reference/README.Reference tomato121/release/src/router/pptp-client/Reference/README.Reference
--- tomato/release/src/router/pptp-client/Reference/README.Reference	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pptp-client/Reference/README.Reference	2008-04-22 21:44:06.000000000 +1000
@@ -0,0 +1,15 @@
+In this directory are the various standards documents implemented in
+the pptp package.
+
+rfc791.txt		Internet Protocol (IP).
+rfc793.txt		Transmission Control Protocol (TCP).
+rfc1661.txt		The Point-to-Point Protocol (PPP).
+rfc1662.txt		PPP in HDLC-like Framing. (serial encoding).
+rfc1701.txt		Generic Routing Encapsulation (GRE).
+rfc1702.txt		Generic Routing Encapsulation over IPv4 networks.
+rfc1990.txt		The PPP Multilink Protocol (MP).
+ms-chap.txt		Microsoft PPP CHAP extensions.
+pptp-draft.txt		July 1997 draft of the PPTP standard.
+
+rfc1990 is currently unimplemented in pptp
+                                                        CSA, 12/12/97
diff -Naur tomato/release/src/router/pptp-client/TODO tomato121/release/src/router/pptp-client/TODO
--- tomato/release/src/router/pptp-client/TODO	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/TODO	2008-04-22 21:44:06.000000000 +1000
@@ -1,11 +1,130 @@
-10th March 2002
+8th April 2005
 
-- redesign to avoid use of setjmp/longjmp.
+On Thu, Apr 07, 2005 at 07:36:41AM -0700, Roark Hennessy wrote:
+> I find in order to get the tunnel working I have to do a
+> route add -host <target_vpn_addr> gateway <my-netgear-wireless-router> dev
++ethN
+> Can this be done automatically in the config somewhere?
+
+Not everybody needs this in order to get the tunnel working, it depends
+on the configuration of the server, and it is problematic calculating
+the correct route to add.  However, the GUI PPTP client (pptpconfig)
+does this automatically, and when done unnecessarily it seems harmless.
+
+I'll take a patch that implements the same thing in C within pptp, so
+that people who don't use the GUI get it done for them.
+
+Here's what the pptpconfig.php program does;
+
+- the IP address of the PPTP server is obtained from the name, using
+  gethostbyname(),
+
+- the command "ip route get $ip | head -1" is executed, where $ip is the
+  IP address determined above, and the result of the command is stored;
+  it is a route specification of the path to the server before the
+  tunnel is started,
+
+- in routing_start(), an "ip route add" command is done using the route
+  specification obtained above,
+
+- when the tunnel is shutdown, an "ip route del" command is done using
+  the same route specification.
+
+I would prefer that the patch implements this by embedding the
+equivalent syscalls within the pptp program, rather than use system() or
+popen() to execute the /usr/sbin/ip program.
+
+I would also prefer that there be a command line option for disabling
+the feature.
+
+
+--
+
+
+10th March 2005
+
+- call manager is not being reused as it was designed to be; if a
+tunnel is started within a minute of a tunnel being stopped, it does
+not succeed; symptom is LCP ConfReq's without any traffic from the
+server.
+
+--
+
+- finish --max-echo-wait
+
+11th August 2004
+
+- add two configurable timeouts for echo generation and echo reply timeout,
+  requested by Tobias Brox.
+
+- ship .spec with tarball.
+
+5th June 2004
+
+- command line as shown by ps is corrupted.  Reported by Andre Ruiz
+  <andre@ruiz.net>
+
+5th June 2004
+
+- on Fedora Core 2, after the tunnel is stopped by the GUI, the pptp
+process spins with a select() on FD's 0 and 1 (the control connection
+and the UNIX domain socket respectively) and read()'s on FD 0 which
+return 0.  Eventually the process stops because of control connection
+ping failure.  Before that happens, any attempt to start another
+connection appears to hang; probably because the process already has a
+raw socket open to receive GRE packets from the server.
+
+pptp should handle a read() returning zero on the control connection
+as a termination.
+
+# lsof
+COMMAND  PID USER   FD   TYPE     DEVICE    SIZE   NODE NAME
+pptp    4082 root    0u  IPv4      12307            TCP lenny.lan:ms-sql-s->quozl.lan:1723 (CLOSE_WAIT)
+pptp    4082 root    1u  unix 0x04698380          12308 /var/run/pptp/255.255.255.255
+pptp    4082 root    2w   CHR        1,3          67097 /dev/null
+pptp    4082 root    3u  unix 0x04698500          12304 socket
+pptp    4082 root    4u   CHR      136,5              7 /dev/pts/5
+pptp    4082 root    5u   CHR      136,5              7 /dev/pts/5
+pptp    4082 root    6u   CHR      136,5              7 /dev/pts/5
+pptp    4082 root    7r  FIFO        0,7          12241 pipe
+pptp    4082 root    8w  FIFO        0,7          12241 pipe
+pptp    4082 root    9u   raw                     12305 0800000A:002F->0500000A:0000 st=01
+pptp    4082 root   10u  unix 0x04698b00          12310 /var/run/pptp/255.255.255.255
+
+# strace
+read(0, "", 512)                        = 0
+select(2, [0 1], [], NULL, NULL)        = 1 (in [0])
+read(0, "", 512)                        = 0
+select(2, [0 1], [], NULL, NULL)        = 1 (in [0])
+
+
+13th February 2004
+
+- timeout connect earlier, with option to extend timeout.
+
+11th June 2003
+
+- support --version  [JJ]
+
+20th May 2003
+
+- GRE stats to a pipe or shared memory, for GUI to use
+
+15th February 2003
+
+- pptp.8 update man page for new options
+- pptp.c long_options array should use NULL for second last arg, not 0
+- pptp.c use getopt_long more simply, e.g. set flags in option array
+
+1st May 2002
+
+- log failure of write() to raw socket, as Ryan Murray
+  <rmurray@debian.org> has encountered an EPERM situation that was not
+  being logged.
 
 12th February 2002
 
 - clean up -T errors in pptp-command,
-- implement GRE reordering from PoPToP to make client more resilient.
 
 23rd December 2000
 
@@ -18,14 +137,5 @@
    GRE encapsulation.  pptp.c must then be modified to use an
    already-existing gre-copy process in the same way it uses an
    already-existing call manager.
-  Support server operation.
-   Obviously, this is more process trickery.  Upon receiving a call
-   request, the call manager must automagically launch new gre/pppd
-   processes to handle it.  Also, some portions of the server control
-   protocol in pptp_ctrl.c have not been completely implemented.
-  More flexible configuration system.
-   pptp needs to read in config options from /etc/pptp or somesuch.
-   This is very necessary for server operation, since presumably we
-   will want to limit the hosts we give PPTP access to.  Maybe not,
-   though.  We could allow everyone and then allow pppd to do the
-   access control.
+
+$Id: TODO,v 1.23 2005/04/07 23:35:11 quozl Exp $	
diff -Naur tomato/release/src/router/pptp-client/USING tomato121/release/src/router/pptp-client/USING
--- tomato/release/src/router/pptp-client/USING	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/USING	2008-04-22 21:44:06.000000000 +1000
@@ -1,4 +1,4 @@
-$Id: USING,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $	
+Usage Notes
 
 pptp is started as a psuedo-tty child process using pppd's pty option:
 
@@ -25,13 +25,16 @@
 manager, a GRE/PPP en/decapsulator, and pppd.  To shut down the pptp
 connection, kill the pppd process.
 
-NOTE THAT PPTP MUST BE RUN AS ROOT.
+NOTE THAT PPTP MUST BE RUN AS ROOT.  This is so that it can generate
+GRE packets using a raw socket.
 
 Most trouble with pptp will probably be due to incorrect pppd
 configuration.  Be sure you thoroughly understand MS-CHAP support in
 pppd.  Use the 'debug' option to pppd to log connection information;
 this will help you trouble-shoot the pppd side of pptp.
 
+See the project web site for diagnosis assistance.
+
 QUIRKS HANDLING:
 
 Some ADSL providers and some ADSL hardware are buggy or not conforming
@@ -45,5 +48,51 @@
 Bezeq, you probably want the '--quirks BEZEQ_ISRAEL' switch.
 
 More information on Bezeq's ADSL service can be found at
-http://www.pointer.co.il/~mulix/adsl-howto.txt and
+http://vipe.technion.il/~mulix/adsl-howto.txt and
 http://damyen.technion.ac.il/~dani/adsl-howto.txt.
+
+TESTING MULTIPLE TUNNELS:
+
+For testing of PPTP servers, the client can be used to establish
+multiple tunnels from multiple IP addresses.  The addresses must be
+routable; this is something you'd do on a local area network.
+
+1. use an address pool on a concentrator.
+
+2. write an ip-up script (e.g. /etc/ppp/ip-up.local or /etc/ppp/ip-up.d)
+
+	#!/bin/sh
+	export PATH=/sbin:/usr/sbin:/bin:/usr/bin
+	REALDEVICE=$1
+	PEERADDR=$6
+	ifconfig ${REALDEVICE} dstaddr ${PEERADDR}
+
+The script performs an "ifconfig pppx dstaddr xx.xx.xx.xx" where
+xx.xx.xx.xx is the private address of the concentrator so that the
+routing works without having to do iptables or ipchains.  The address
+used is given on the pptp command line.
+
+3. create distinct source interfaces with:
+
+        ifconfig eth0:n xx.xx.xx.xx netmask yy.yy.yy.yy 
+
+Where "n" is the alias interface number, "xx.xx.xx.xx" is the new
+address, and "yy.yy.yy.yy" is the network mask.
+
+4. connect with
+
+	pptp concentrator --bind xx.xx.xx.xx name \
+        xx remotename yy ipparam yy.yy.yy.yy 
+                                       ^ (private address of concentrator).
+
+Where "xx.xx.xx.xx" is the address of the source interface, "xx" is
+the local name of the tunnel, "yy" is the remote name of the tunnel,
+and "yy.yy.yy.yy" is the private address of the concentrator.  This is
+passed to the ip-up script as the sixth argument.
+
+See also the following test scripts;
+
+test-multiple-tunnels-1.sh  creates multiple source interfaces
+test-multiple-tunnels-2.sh  creates multiple tunnels
+
+$Id: USING,v 1.6 2003/02/15 04:32:50 quozl Exp $	
